// WMSEDlg.cpp : implementation file
//

#include "stdafx.h"
#include "WMSE.h"
#include "WMSEDlg.h"
#include "SPropDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CWMSEDlg dialog

CWMSEDlg::CWMSEDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CWMSEDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CWMSEDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CWMSEDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CWMSEDlg)
	DDX_Control(pDX, IDC_EDIT, m_bEdit);
	DDX_Control(pDX, IDC_DELETE, m_bDelete);
	DDX_Control(pDX, IDC_MOOLIST, m_cMOOList);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CWMSEDlg, CDialog)
	//{{AFX_MSG_MAP(CWMSEDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_CREATE, OnCreate)
	ON_LBN_SELCHANGE(IDC_MOOLIST, OnSelchangeMoolist)
	ON_LBN_SELCANCEL(IDC_MOOLIST, OnSelcancelMoolist)
	ON_BN_CLICKED(IDC_EDIT, OnEdit)
	ON_BN_CLICKED(IDC_DELETE, OnDelete)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CWMSEDlg message handlers

BOOL CWMSEDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	CString strAboutMenu;
	strAboutMenu.LoadString(IDS_ABOUTBOX);
	if (!strAboutMenu.IsEmpty())
	{
		pSysMenu->AppendMenu(MF_SEPARATOR);
		pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here

  if (!FindMOOs())
  {
    AfxMessageBox("Couldn't read list of MOOs; quitting.", MB_OK);
    EndDialog(IDCANCEL);
  }
	
  m_bEdit.EnableWindow(FALSE);
  m_bDelete.EnableWindow(FALSE);

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CWMSEDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CWMSEDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CWMSEDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

int
CWMSEDlg::FindMOOs(void)
{
  HKEY k1, k2;
  LONG res;
  DWORD dispo;

  // open Software registry section

  if ((res=RegOpenKeyEx(HKEY_LOCAL_MACHINE, "Software",
                        0, KEY_ALL_ACCESS, &k1))!=ERROR_SUCCESS)
    return 0;

  if ((res=RegCreateKeyEx(k1, "WinMOO", 0, "", REG_OPTION_NON_VOLATILE,
                          KEY_ALL_ACCESS, NULL, &k2, &dispo))!=ERROR_SUCCESS)
    return 0;
  RegCloseKey(k1);

  if ((res=RegCreateKeyEx(k2, "WinMOOServices", 0, "", REG_OPTION_NON_VOLATILE,
                          KEY_ALL_ACCESS, NULL, &k1, &dispo))!=ERROR_SUCCESS)
    return 0;
  RegCloseKey(k2);

  DWORD numsubkey, subkeynamelen;

  if (RegQueryInfoKey(k1, NULL, NULL, NULL, &numsubkey, &subkeynamelen,
                      NULL, NULL, NULL, NULL, NULL, NULL)!=
      ERROR_SUCCESS)
    return 0;

  subkeynamelen=subkeynamelen*2+1;
  char *mooname = new char[subkeynamelen+1];

  DWORD i, tmp;
  for (i=0; i<numsubkey; i++)
  {
    tmp=subkeynamelen;
    if ((res=RegEnumKeyEx(k1, i, mooname, &tmp, 0, NULL, NULL, NULL))
        != ERROR_SUCCESS)
      return 0;
    if (_strnicmp(mooname, "winmoo", 6))
      continue;
    m_cMOOList.AddString(mooname+6);
  }
  m_cMOOList.SetSel(-1, FALSE);

  delete[] mooname;
  m_hServiceKey = k1;
  return 1;
}

void CWMSEDlg::OnCreate() 
{
  CSPropDlg dlg(this);

  if (dlg.DoModal()==IDOK)
  {
    AddMOO(dlg.m_sServiceName, dlg.m_sSourceFile, dlg.m_sDestFile,
           dlg.m_sLogFile, dlg.m_sStartup, dlg.m_iPort, dlg.m_bONS, dlg.m_sExecutable,
           dlg.m_sPlugins);
  }
}

typedef CONST BYTE * CBP;

void
CWMSEDlg::AddMOO(CString ServiceName, CString SourceFile, CString DestFile,
                 CString LogFile, CString Startup, int Port, BOOL ONS,
                 CString Executable, CString Plugins)
{
  // create a new subkey in Software\WinMOO\WinMOOServices for this service

  HKEY skey;
  DWORD dispo;

  CString keyname = CString("winmoo")+ServiceName;

  if (RegCreateKeyEx(m_hServiceKey, keyname, 0, "", REG_OPTION_NON_VOLATILE,
                     KEY_ALL_ACCESS, NULL, &skey, &dispo) != ERROR_SUCCESS)
  {
    AfxMessageBox("Service creation failed: couldn't open registry key.", MB_OK);
    return;
  }
  else if (dispo==REG_OPENED_EXISTING_KEY)
  {
    AfxMessageBox("Service creation failed: registry key already exists.", MB_OK);
    RegCloseKey(skey);
    return;
  }

  char portnum[20];
  sprintf(portnum, "%d", Port);

  if ((RegSetValueEx(skey, "SOURCEFILE", 0, REG_SZ, (CBP)(LPCTSTR)SourceFile,
       SourceFile.GetLength()+1) != ERROR_SUCCESS) ||
      (RegSetValueEx(skey, "DESTFILE", 0, REG_SZ, (CBP)(LPCTSTR)DestFile,
       DestFile.GetLength()+1) != ERROR_SUCCESS) ||
      (RegSetValueEx(skey, "LOGFILE", 0, REG_SZ, (CBP)(LPCTSTR)LogFile,
       LogFile.GetLength()+1) != ERROR_SUCCESS) ||
      (RegSetValueEx(skey, "STARTUP", 0, REG_SZ, (CBP)(LPCTSTR)Startup,
       Startup.GetLength()+1) != ERROR_SUCCESS) ||
      (RegSetValueEx(skey, "PORT", 0, REG_SZ, (CBP)portnum,
       strlen(portnum)+1) != ERROR_SUCCESS) ||
      (RegSetValueEx(skey, "PLUGINS", 0, REG_SZ, (CBP)(LPCTSTR)Plugins,
         Plugins.GetLength()+1) != ERROR_SUCCESS) ||
      (RegSetValueEx(skey, "ONS", 0, REG_SZ, (CBP)(ONS==TRUE ? "Y" : "N"), 2) != ERROR_SUCCESS))
  {
    AfxMessageBox("Service creation failed: couldn't set values in registry.", MB_OK);
    RegCloseKey(skey);
    return;
  }

  SC_HANDLE schService, schSCManager;

  schSCManager = OpenSCManager(NULL, NULL, SC_MANAGER_ALL_ACCESS);

  if (!schSCManager)
  {
    AfxMessageBox("Service creation failed: couldn't open service control manager.", MB_OK);
    RegCloseKey(skey);
    return;
  }

  CString displayname = CString("WinMOO ") + ServiceName + CString(" Service");

  schService = CreateService(
    schSCManager,
    keyname,
    displayname,
    SERVICE_ALL_ACCESS,
    SERVICE_WIN32_OWN_PROCESS,
    SERVICE_DEMAND_START,
    SERVICE_ERROR_NORMAL,
    Executable,
    NULL,
    NULL,
    "\0",
    NULL,
    NULL);


  RegCloseKey(skey);

  if (!schService)
  {
    AfxMessageBox("Service creation failed: couldn't create NT service.", MB_OK);
    return;
  }                          

  m_cMOOList.AddString(ServiceName);
  m_cMOOList.SetSel(-1, FALSE);

	m_bEdit.EnableWindow(FALSE);
  m_bDelete.EnableWindow(FALSE);
}

void CWMSEDlg::OnOK() 
{
	RegCloseKey(m_hServiceKey);
	
	CDialog::OnOK();
}


void CWMSEDlg::OnSelchangeMoolist() 
{
	// something is selected, so enable Edit... and Delete.. buttons

  m_bEdit.EnableWindow(TRUE);
  m_bDelete.EnableWindow(TRUE);
}

void CWMSEDlg::OnSelcancelMoolist() 
{
	m_bEdit.EnableWindow(FALSE);
  m_bDelete.EnableWindow(FALSE);
	
}

typedef BYTE * BP;

void CWMSEDlg::OnEdit() 
{
	CSPropDlg dlg(this);
  CString mooname;

  dlg.editing=1;

  m_cMOOList.GetText(m_cMOOList.GetCurSel(), mooname);

  CString regkey=CString("winmoo") + mooname;
  HKEY skey;

  if (RegOpenKeyEx(m_hServiceKey, regkey, 0, KEY_ALL_ACCESS, &skey)!=ERROR_SUCCESS)
  {
    AfxMessageBox("Edit failed: couldn't retrieve current values from registry.", MB_OK);
    return;
  }

  DWORD valuelen;
  if (RegQueryInfoKey(skey, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
        &valuelen, NULL, NULL)!=ERROR_SUCCESS)
  {
    AfxMessageBox("Edit failed: couldn't query key info.", MB_OK);
    RegCloseKey(skey);
    return;
  }

  char *values[7];
  DWORD type[7];
  DWORD lens[7];
  DWORD res[7];
  int i;

  valuelen++;
  valuelen*=2;
  for (i=0; i<7; i++)
  {
    values[i]=new char[valuelen];
    lens[i]=valuelen;
  }

  if (((res[0]=RegQueryValueEx(skey, "SOURCEFILE", NULL, &type[0], (BP)values[0], &lens[0]))
       != ERROR_SUCCESS) ||
      ((res[1]=RegQueryValueEx(skey, "DESTFILE", NULL, &type[1], (BP)values[1], &lens[1]))
       != ERROR_SUCCESS) ||
      ((res[2]=RegQueryValueEx(skey, "LOGFILE", NULL, &type[2], (BP)values[2], &lens[2]))
       != ERROR_SUCCESS) ||
      ((res[3]=RegQueryValueEx(skey, "STARTUP", NULL, &type[3], (BP)values[3], &lens[3]))
       != ERROR_SUCCESS) ||
      ((res[4]=RegQueryValueEx(skey, "PORT", NULL, &type[4], (BP)values[4], &lens[4]))
       != ERROR_SUCCESS) ||
      ((res[5]=RegQueryValueEx(skey, "ONS", NULL, &type[5], (BP)values[5], &lens[5]))
       != ERROR_SUCCESS) ||
      ((res[6]=RegQueryValueEx(skey, "PLUGINS", NULL, &type[6], (BP)values[6], &lens[6]))
       != ERROR_SUCCESS))
  {
    AfxMessageBox("Edit failed: couldn't get current values.", MB_OK);
    RegCloseKey(skey);
    for (i=0; i<6; i++)
      delete[] values[i];
    return;
  }
 
  for (i=0; i<6; i++)
    if (type[i]!=REG_SZ)
    {
      AfxMessageBox("Edit failed: current data is corrupt.", MB_OK);
      RegCloseKey(skey);
      for (i=0; i<6; i++)
        delete[] values[i];
    }

  dlg.m_sServiceName=mooname;
  dlg.m_sSourceFile=values[0];
  dlg.m_sDestFile=values[1];
  dlg.m_sLogFile=values[2];
  dlg.m_sStartup=values[3];
  dlg.m_iPort=atoi(values[4]);
  if (values[5][0]=='Y' || values[5][0]=='y')
    dlg.m_bONS=TRUE;
  else
    dlg.m_bONS=FALSE;
  dlg.m_sPlugins=values[6];

  if (dlg.DoModal()==IDOK)
  {
    char portnum[20];
    sprintf(portnum, "%d", dlg.m_iPort);

    if ((RegSetValueEx(skey, "SOURCEFILE", 0, REG_SZ, (CBP)(LPCTSTR)dlg.m_sSourceFile,
         dlg.m_sSourceFile.GetLength()+1) != ERROR_SUCCESS) ||
        (RegSetValueEx(skey, "DESTFILE", 0, REG_SZ, (CBP)(LPCTSTR)dlg.m_sDestFile,
         dlg.m_sDestFile.GetLength()+1) != ERROR_SUCCESS) ||
        (RegSetValueEx(skey, "LOGFILE", 0, REG_SZ, (CBP)(LPCTSTR)dlg.m_sLogFile,
         dlg.m_sLogFile.GetLength()+1) != ERROR_SUCCESS) ||
        (RegSetValueEx(skey, "STARTUP", 0, REG_SZ, (CBP)(LPCTSTR)dlg.m_sStartup,
         dlg.m_sStartup.GetLength()+1) != ERROR_SUCCESS) ||
        (RegSetValueEx(skey, "PORT", 0, REG_SZ, (CBP)portnum,
         strlen(portnum)+1) != ERROR_SUCCESS) ||
        (RegSetValueEx(skey, "PLUGINS", 0, REG_SZ, (CBP)(LPCTSTR)dlg.m_sPlugins,
         dlg.m_sPlugins.GetLength()+1) != ERROR_SUCCESS) ||
        (RegSetValueEx(skey, "ONS", 0, REG_SZ, (CBP)(dlg.m_bONS==TRUE ? "Y" : "N"), 2) != ERROR_SUCCESS))
    {
      AfxMessageBox("Edit failed: couldn't update values.", MB_OK);
    }
  }

  for (i=0; i<6; i++)
    delete[] values[i];
  RegCloseKey(skey);
}


void CWMSEDlg::OnDelete() 
{
  CString mooname;
  CString keyname;
  int success=1;
  CString errortext("Errors occurred during service removal:");
	
  m_cMOOList.GetText(m_cMOOList.GetCurSel(), mooname);

  keyname = CString("winmoo") + mooname;

  if (RegDeleteKey(m_hServiceKey, keyname)!=ERROR_SUCCESS)
  {
    success=0;
    errortext+="\nRegistry key could not be removed.";
  }

  SC_HANDLE schService, schSCManager;
  SERVICE_STATUS ss;

  schSCManager = OpenSCManager(NULL, NULL, SC_MANAGER_ALL_ACCESS);

  if (!schSCManager)
  {
    success=0;
    errortext+="\nService control manager could not be opened.";
  }
  else
  {
    schService = OpenService(schSCManager, keyname, SERVICE_ALL_ACCESS);
    if (!schService)
    {
      success=0;
      errortext+="\nService could not be opened.";
    }
    else
    {
      if (ControlService(schService, SERVICE_CONTROL_STOP, &ss))
      {
        Sleep(1000);

        while (QueryServiceStatus(schService, &ss))
        {
          if (ss.dwCurrentState==SERVICE_STOP_PENDING)
          {
            Sleep(1000);
          }
          else
            break;
        }

        if (ss.dwCurrentState!=SERVICE_STOPPED)
        {
          success=0;
          errortext+="\nService failed to stop.";
        }
      }

      if (!DeleteService(schService))
      {
        success=0;
        errortext+="\nService could not be removed.";
      }
      CloseServiceHandle(schService);
    }
    CloseServiceHandle(schSCManager);
  }

  
  if (!success)
  {
    AfxMessageBox(errortext, MB_OK);
  }
  else
  {
    int index;

    index=m_cMOOList.GetCurSel();

    m_cMOOList.SetSel(-1, FALSE);
    m_cMOOList.DeleteString(index);

  	m_bEdit.EnableWindow(FALSE);
    m_bDelete.EnableWindow(FALSE);
  }
 
}
