#include <windows.h>
#include <string.h>

/* This function must be a __declspec(dllexport) function named StartupProc.
 * The NT service version of WinMOO calls this function, with the arguments the
 * path name to the source and destination databases, *before* it begins reading
 * the database.  This can be used to perform the functions that happen in the
 * restart script distribued with LambdaMOO, or other startup tasks.
 * 
 * Returns true on success to indicate that startup should continue, or false
 * to indicate that server startup should be aborted.
 */
__declspec ( dllexport ) int StartupProc(const char *source, const char * dest)
{
  char old[256];

  strcpy(old, source);
  strcat(old, ".old");

  if (CopyFile(source, old, FALSE) &&
      CopyFile(dest, source, FALSE))
  {
    return 1;
  }
  else
  {
    return 0;
  }
}